[ISPP]
#define AppName "Admin Tray"

[Setup]
VersionInfoVersion=0.1.0.0
VersionInfoTextVersion=Ver. 0.1.0.0
OutputDir=C:\Users\Jim\Desktop\Admin tray\Current
OutputBaseFilename=Admin_Tray_Setup
AppName={#AppName}
AppId={{AFF04D58-481C-4C14-A5BF-E4BCFF26BEA9}
AppVersion=0.2.0.0
AppVerName=0.2.0.0
DefaultDirName={pf32}\{#AppName}
DefaultGroupName={#AppName}
MinVersion=0,5.01.2600
UninstallFilesDir={app}\Uninstall Information
AppCopyright=JSComputerTech
RestartIfNeededByRun=false
PrivilegesRequired=admin
Compression=lzma/ultra
SourceDir=C:\Users\Jim\Desktop\Admin tray\Current
VersionInfoCompany=JSComputerTech
VersionInfoDescription=Admin Tray Ver. 0.2.0.0 provides easy access to system tools for administrators.
AllowNoIcons=True
AlwaysShowDirOnReadyPage=true
AlwaysShowGroupOnReadyPage=true
AllowUNCPath=false
OutputManifestFile=C:\Users\Jim\Desktop\Admin tray\Current\manifest.txt
VersionInfoCopyright=JSComputerTech
InternalCompressLevel=ultra
CompressionThreads=2
AllowCancelDuringInstall=false
AppPublisher=JSComputerTech
AppPublisherURL=http://jscomputertech.com/admintray
AppSupportURL=http://www.autoitscript.com/forum/index.php?showtopic=58997
AppUpdatesURL=http://jscomputertech.com/admintray
AppComments=Admin Tray
AppReadmeFile={app}\readme.txt
UninstallDisplayIcon={app}\Admin Tray.exe
UninstallDisplayName=Admin Tray
TerminalServicesAware=False
AlwaysUsePersonalGroup=True
WizardImageFile=compiler:WizModernImage-IS.bmp
WizardSmallImageFile=compiler:WizModernSmallImage-IS.bmp
ShowLanguageDialog=no
FlatComponentsList=False
ShowTasksTreeLines=True
SolidCompression=True

[Components]
Name: tray; Description: Executable Files; Types: full compact normal; Flags: checkablealone dontinheritcheck; MinVersion: 0,5.01.2600
Name: menu; Description: Sample Menu Config; Types: full normal; MinVersion: 0,5.01.2600
Name: taskimport; Description: Run at logon with administrative privileges, Via Task Scheduler.; Types: full normal; MinVersion: 0,6.0.6000
Name: startup; Description: Add to startup; Types: normal full; MinVersion: 0,5.01.2600; OnlyBelowVersion: 0,5.2
Name: Source; Description: Source Files; Types: full; Flags: checkablealone dontinheritcheck

[Files]
Source: Admin Tray.exe; DestDir: {app}; Flags: ReplaceSameVersion; MinVersion: 0,5.01.2600; Components: tray
Source: Item Command options.txt; DestDir: {app}; Flags: comparetimestamp; Components: tray
Source: xmllayout.xml; DestDir: {app}; Flags: comparetimestamp; Components: tray
Source: ReadMe.txt; DestDir: {app}; Flags: comparetimestamp isreadme; Components: tray
Source: AdminTrayTaskImport.exe; DestDir: {app}; Flags: replacesameversion comparetimestamp; MinVersion: 0,6.0.6000; Components: taskimport
Source: roaming\Admin Tray.xml; DestDir: {userappdata}\{#AppName}; Flags: uninsneveruninstall onlyifdoesntexist; Components: menu
Source: programdata\Windows_Command.ico; DestDir: {commonappdata}\{#AppName}\Icons; Flags: comparetimestamp; Components: menu
Source: Admin Tray.au3; DestDir: {app}\Source; Flags: comparetimestamp; Components: Source
Source: Includes\_AdminTray.au3; DestDir: {app}\Source\Includes; Flags: comparetimestamp; Components: Source
Source: Includes\_XMLDomWrapper.au3; DestDir: {app}\Source\Includes; Flags: comparetimestamp; Components: Source
Source: Includes\ModernMenu.au3; DestDir: {app}\Source\Includes; Flags: comparetimestamp; Components: Source
Source: Includes\Shell32.au3; DestDir: {app}\Source\Includes; Flags: comparetimestamp; Components: Source
Source: AdminTrayTaskImport.au3; DestDir: {app}\Source; Flags: comparetimestamp; Components: Source
Source: Template\task.xml; DestDir: {app}\Source\Template; Flags: comparetimestamp; Components: Source
Source: Icons\miguiresource_600.ico; DestDir: {app}\Source\icons; Flags: comparetimestamp; Components: Source
Source: Icons\shell32_40.ico; DestDir: {app}\Source\Icons; Flags: comparetimestamp; Components: Source
Source: IssProc.dll; DestDir: {app}; Flags: ignoreversion

[_ISTool]
UseAbsolutePaths=false
OutputExeFilename=C:\Users\Jim\Desktop\Admin tray\Current\Admin_Tray_Setup.exe

[Dirs]
Name: {commonappdata}\{#AppName}; MinVersion: 0,5.01.2600; Components: tray
Name: {commonappdata}\{#AppName}\Icons; MinVersion: 0,5.01.2600; Components: tray
Name: {userappdata}\{#AppName}; MinVersion: 0,5.01.2600; Components: tray

[Run]
Filename: {app}\Admin Tray.exe; Description: Run Admin Tray Now; WorkingDir: {app}; Flags: postinstall runascurrentuser nowait skipifsilent; Components: tray
Filename: {app}\AdminTrayTaskImport.exe; Parameters: 1; WorkingDir: {app}; StatusMsg: Scheduling Task...; Flags: runascurrentuser; MinVersion: 0,6.0.6000; Components: taskimport

[UninstallRun]
Filename: {app}\AdminTrayTaskImport.exe; Parameters: 0; WorkingDir: {app}; StatusMsg: Removing Admin Tray Scheduled Task; MinVersion: 0,6.0.6000; Components: taskimport

[Icons]
Name: {group}\Admin Tray; Filename: {app}\Admin Tray.exe; Flags: createonlyiffileexists; MinVersion: 0,5.01.2600; Components: tray
Name: {group}\Task\Add or Remove Scheduled Task; Filename: {app}\AdminTrayTaskImport.exe; WorkingDir: {app}; Comment: Add or remove Admin Tray AutoStart; Flags: createonlyiffileexists; MinVersion: 0,6.0.6000; Components: taskimport
Name: {group}\Uninstall; Filename: {uninstallexe}; Comment: Uninstall Admin Tray; Flags: createonlyiffileexists; MinVersion: 0,5.01.2600; Components: tray Source
Name: {group}\Links\Admin Tray Homepage; Filename: http://www.jscomputertech.com/admintray/
Name: {group}\Links\Admin Tray on AutoIT Forum; Filename: http://www.autoitscript.com/forum/index.php?showtopic=58997
Name: {userstartup}\Admin Tray; Filename: {app}\Admin Tray.exe; MinVersion: 0,5.01.2600; OnlyBelowVersion: 0,5.2; Components: startup

[Types]
Name: full; Description: Full Installation
Name: normal; Description: Normal Installation
Name: custom; Description: Custom Installation; Flags: iscustom
Name: compact; Description: Compact Installation

[Tasks]

[Code]

const
    NL = #13#10;    //carriage return and line feed

//*********************************************************************************
//confirm file deletion and then delete the file
//*********************************************************************************
function DeleteOneFile(sFullFilePath: String): Boolean;
var
 iAns: Integer;
 SucInDel: Boolean;

begin

iAns := MsgBox(sFullFilePath +NL+NL+ 'Admin Tray is no longer using this file, would you like to remove it from your system?', mbConfirmation, MB_YESNO or MB_DEFBUTTON2);
 if iAns = IDYES then SucInDel := DeleteFile(sFullFilePath);
end;

//*********************************************************************************
//cycles through all files that match a spec and then
//asks the user if they would like to delete them.
//*********************************************************************************
procedure DeleteManyFiles(sPattern: String);
var
 PathD: String;
 FileD: String;
 ExistsD: Boolean;
 FindRec: TFindRec;

begin

 //test to see if a files matching a pattern still exists. if they do exist then we
 //ask the user if they want to delete each one
 PathD := AddBackslash(ExpandConstant('{app}'))
 if FindFirst(ExpandConstant(PathD + sPattern), FindRec) then begin
   try
     repeat
       //only check files and not directories
       if FindRec.Attributes and FILE_ATTRIBUTE_DIRECTORY = 0 then
         //we found one file that matches our wildcards
         begin

            //FindFirst returns the name of the file with no path so must account for that
            FileD := PathD + FindRec.Name
            ExistsD := FileExists(FileD);

            //ask to delete the found file
            if ExistsD = true then DeleteOneFile(FileD);
         end;
     until not FindNext(FindRec);
   finally
     FindClose(FindRec);
   end;
 end;
end;

//*********************************************************************************
//deletes (with prompt) three individual files.
//deletes (with prompt) all files that match a pattern
//*********************************************************************************
procedure DeleteUserFiles();
var
 FileA: String;
 FileB: String;
 //FileC: String;
 ExistsA: Boolean;
 ExistsB: Boolean;
 //ExistsC: Boolean;

begin
 //test to see if the INI file and LOG files still exist
 FileA := ExpandConstant('{userappdata}\{#AppName}\Admin Tray.xml');
 FileB := ExpandConstant('{commonappdata}\{#AppName}\Icons\Windows_Command.ico');
// FileC := ExpandConstant('{app}\Process.log');
 ExistsA := FileExists(FileA);
 ExistsB := FileExists(FileB);
// ExistsC := FileExists(FileC);

 //ask to delete the INI and LOG files
 if ExistsA = true then DeleteOneFile(FileA);
 if ExistsB = true then DeleteOneFile(FileB);
// if ExistsC = true then DeleteOneFile(FileC);


 //test to see if MDB files still exists. the MDB files are generated based on
 //user ID so we cycle through all the existing databases in the app folder and
 //ask the user if they want to delete each one
//DeleteManyFiles('{commonappdata}\{#AppName}\Icons\*.*');
// DeleteManyFiles('??????YY.mdb');
// DeleteManyFiles('??????ZZ.mdb');
end;

//*********************************************************************************
//this is the main calling point when the uninstall begins. we do this because the
//folder will be automatically be deleted at the END of this step, IF the folder no
//longer contains any files
//*********************************************************************************
procedure CurUninstallStepChanged(CurUninstallStep: TUninstallStep);
begin
 case CurUninstallStep of
   usUninstall:
     begin
       DeleteUserFiles;
     end;
 end;
end;





    // IssFindModule called on install
function IssFindModule(hWnd: Integer; Modulename: PChar; Language: PChar; Silent: Boolean; CanIgnore: Boolean ): Integer;
external 'IssFindModule@files:IssProc.dll stdcall setuponly';

// IssFindModule called on uninstall
function IssFindModuleU(hWnd: Integer; Modulename: PChar; Language: PChar; Silent: Boolean; CanIgnore: Boolean ): Integer;
external 'IssFindModule@{app}\IssProc.dll stdcall uninstallonly';

//********************************************************************************************************************************************
// IssFindModule function returns: 0 if no module found; 1 if cancel pressed; 2 if ignore pressed; -1 if an error occured
//
//  hWnd        = main wizard window handle.
//
//  Modulename  = module name(s) to check. You can use a full path to a DLL/EXE/OCX or wildcard file name/path. Separate multiple modules with semicolon.
//                 Example1 : Modulename='*mymodule.dll';     -  will search in any path for mymodule.dll
//                 Example2 : Modulename=ExpandConstant('{app}\mymodule.dll');     -  will search for mymodule.dll only in {app} folder (the application directory)
//                 Example3 : Modulename=ExpandConstant('{app}\mymodule.dll;*myApp.exe');   - just like Example2 + search for myApp.exe regardless of his path.
//
//  Language    = files in use language dialog. Set this value to empty '' and default english will be used
//                ( see and include IssProcLanguage.ini if you need custom text or other language)
//
//  Silent      = silent mode : set this var to true if you don't want to display the files in use dialog.
//                When Silent is true IssFindModule will return 1 if it founds the Modulename or 0 if nothing found
//
//  CanIgnore   = set this var to false to Disable the Ignore button forcing the user to close those applications before continuing
//                set this var to true to Enable the Ignore button allowing the user to continue without closing those applications
//******************************************************************************************************************************************


function NextButtonClick(CurPage: Integer): Boolean;
var
  hWnd: Integer;
  sModuleName: String;
  nCode: Integer;  {IssFindModule returns: 0 if no module found; 1 if cancel pressed; 2 if ignore pressed; -1 if an error occured }
begin
  Result := true;

 if CurPage = wpReady then
   begin
      Result := false;
      hWnd := StrToInt(ExpandConstant('{wizardhwnd}'));                     { get main wizard handle }
      sModuleName :=ExpandConstant('{app}\Admin Tray.exe');                        { searched modules. Tip: separate multiple modules with semicolon Ex: '*mymodule.dll;*mymodule2.dll;*myapp.exe'}

     nCode:=IssFindModule(hWnd,sModuleName,'en',false,true);                { search for module and display files-in-use window if found  }
     //sModuleName:=IntToStr(nCode);
     //MsgBox ( sModuleName, mbConfirmation, MB_YESNO or MB_DEFBUTTON2);

     if nCode=1 then  begin                                                 { cancel pressed or files-in-use window closed }
          PostMessage (WizardForm.Handle, $0010, 0, 0);                     { quit setup, $0010=WM_CLOSE }
     end else if (nCode=0) or (nCode=2) then begin                          { no module found or ignored pressed}
          Result := true;                                                   { continue setup  }
     end;

  end;

end;


function InitializeUninstall(): Boolean;
var
  sModuleName: String;
  nCode: Integer;  {IssFindModule returns: 0 if no module found; 1 if cancel pressed; 2 if ignore pressed; -1 if an error occured }

begin
    Result := false;
     sModuleName := ExpandConstant('{app}\Admin Tray.exe');          { searched module. Tip: separate multiple modules with semicolon Ex: '*mymodule.dll;*mymodule2.dll;*myapp.exe'}

     nCode:=IssFindModuleU(0,sModuleName,'enu',false,false); { search for module and display files-in-use window if found  }

     if (nCode=0) or (nCode=2) then begin                    { no module found or ignored pressed}
          Result := true;                                    { continue setup  }
     end;

    // Unload the extension, otherwise it will not be deleted by the uninstaller
    UnloadDLL(ExpandConstant('{app}\IssProc.dll'));

end;
