#NoTrayIcon
#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=Icons\shell32_40.ico
#AutoIt3Wrapper_outfile=Admin Tray.exe
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_Res_Comment=Admin Tray
#AutoIt3Wrapper_Res_Description=Admin Tray
#AutoIt3Wrapper_Res_Fileversion=0.2.0.0
#AutoIt3Wrapper_Res_LegalCopyright=JSComputerTech
#AutoIt3Wrapper_Res_SaveSource=y
#AutoIt3Wrapper_Res_Language=1033
#AutoIt3Wrapper_Run_Tidy=y
#Tidy_Parameters=/sf
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ----------------------------------------------------------------------------
	
	AutoIt Version: 			3.2.10.0
	
	Script Name:				AdminTray.au3
	http://www.autoitscript.com/forum/index.php?showtopic=58997
	
	Author:						James R Feig III
	AutoITScript.com Forum id:	toyotabedzrock
	
	_XMLDomWrapper.au3 	BY:		ElTorro
	http://www.autoitscript.com/forum/index.php?showtopic=19848
	
	ModernMenu.au3 		BY:		Holger
	http://www.autoitscript.com/forum/index.php?showtopic=20967&hl=systray
	
	Shell32.au3			BY:		kjactive
	http://www.autoitscript.com/forum/index.php?showtopic=58940
	
	Script Function:
	Parse XML file and creates a tray menu with icons.
	Also allows you to execute single commands in AutoIT i.e. _OpenDialog(3) for the run box. See Exit and Run commands in the XML file for proper formating.
	
#ce ----------------------------------------------------------------------------

#include "Includes\_XMLDomWrapper.au3"
#include "Includes\ModernMenu.au3"
#include "Includes\_AdminTray.au3"
#include "Includes\Shell32.au3"



Opt("TrayMenuMode", 1)
Opt("ExpandEnvStrings", 1)

_TrayIconSetClick(-1, 9)

Global Const $menuFile = @AppDataDir & "\" & StringTrimRight(@ScriptName, 4) & "\" & StringTrimRight(@ScriptName, 4) & ".xml"

Global $aTray
Global $xmlFile

Global $trayItems[1][2]
$trayItems[0][0] = 1

Dim $Item = ""

If FileExists($menuFile) Then

	$xmlFile = _XMLFileOpen($menuFile)

Else

	MsgBox(16, "Missing Menu File Error", StringTrimRight(@ScriptName, 4) & " Could not find " & $menuFile)
	Exit
	
EndIf

_Parse($trayItems)

While 1

	$Msg = GUIGetMsg()
	
	If IsTrayItem($Msg) Then
		
		For $is = 1 To(($trayItems[0][0]) - 1)
			
			If $trayItems[$is][0] == $Msg Then
				
				$Item = $trayItems[$is][1]
				
			EndIf
			
		Next
		
		_runCommand($Item)
		
	EndIf
	
	Sleep(10)

WEnd

_TrayIconDelete($aTray)

Exit